-module(g_math_server).
-import(math_stuff,[factorial/1]).
-export([start/0, compute_factorial/2, get_count/1]).

start() ->
    g_server:start(math_server, 0, fun fx/2).

fx(Count, {factorial, N}) ->
    Result = factorial(N),
    {Result, Count+1};
fx(Count, get_count) ->
    {Count, Count}.

compute_factorial(Pid, N) ->
    g_server:request(Pid, {factorial, N}).

get_count(Pid) ->
    g_server:request(Pid, get_count).
