-module(math_server).
-import(math_stuff,[factorial/1]).
-export([start/0, compute_factorial/2, get_count/1]).

start() ->
    Pid = spawn(fun() -> loop(0) end),
    register(math_server, Pid),
    Pid.

loop(Count) ->
    receive
	{factorial, From, Ref, N} ->
	    Result = factorial(N),
	    From ! {result, Ref, Result},
	    loop(Count+1);
	{get_count, From, Ref} ->
	    From ! {result, Ref, Count},
	    loop(Count);
	stop -> true
    end.

compute_factorial(Pid, N) ->
    Ref = make_ref(),
    Pid!{factorial, self(), Ref, N},
    receive
	{result, Ref, Result} ->
	    Result
    end.

get_count(Pid) ->
    Ref = make_ref(),
    Pid!{get_count, self(), Ref},
    receive
	{result, Ref, Result} ->
	    Result
    end.
