-module(semaphore).
-export([make/1, p/1, v/1]).

make(Permits) ->
    spawn(fun() -> loop(Permits) end).

p(Sem) ->
    Ref = make_ref(),
    Sem!{acquire, self(), Ref},
    receive
	{acquired, Ref} -> ok
    end.

v(Sem) ->
    Sem!release.

loop(Permits) ->
    receive
	{acquire,Pid,Ref} when Permits>0 ->
	    Pid!{acquired, Ref},
	    loop(Permits-1);
	release ->
	    loop(Permits+1)
    end.
