-module(semaphore_fsm).
-export([make/1, p/1, v/1]).

make(Permits) ->
    spawn(fun() -> loop(Permits) end).

p(Sem) ->
    Ref = make_ref(),
    Sem!{acquire, self(), Ref},
    receive
	{acquired, Ref} -> ok
    end.

v(Sem) ->
    Sem!release.

loop(0) ->
    loop_release();
loop(Permits) ->
    loop_both(Permits).

loop_release() ->
    receive
	release ->
	    loop_both(1)
    end.

loop_both(Permits) ->
    receive
	{acquire, Pid, Ref} ->
	    Pid!{acquired, Ref},
	    if (Permits-1)==0 ->
		    loop_release();
	       true ->
		    loop_both(Permits-1)
	    end;
	release ->
	    loop_both(Permits+1)
    end.
